﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Globalization;

namespace sf_dp_cs
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            decimal d = default(decimal);
            if (decimal.TryParse(TextBox1.Text, out d) && d != 0)
            {
                int f = Convert.ToInt32(NumericUpDown1.Value);
                Label1.Text = string.Format("{0} ({1} dp)", DecimalPlaces(d, f), f);
            }
            else
            {
                Label1.Text = "Invalid input";
            }

        }

        private void Button1_Click(object sender, EventArgs e)
        {
            decimal d = default(decimal);
            if (decimal.TryParse(TextBox1.Text, out d) && d != 0)
            {
                string s = TextBox1.Text;
                int fSF = Array.FindIndex(s.ToArray(), (char c) => c != '0' && c != '.');
                int dp = s.IndexOf(".");
                int l = s.Length;
                int f = Convert.ToInt32(NumericUpDown1.Value);
                int places = 0;
                if (dp == -1)
                {
                    places = f - l;
                }
                else
                {
                    places = fSF - dp + f + (fSF > 0 ? -1 : 0);
                }
                decimal output = DecimalPlaces(SignificantFigures(d, f), Math.Max(places, 0));
                Label1.Text = string.Format("{0} ({1} sf)", output, f);
            }
            else
            {
                Label1.Text = "Invalid input";
            }

        }

        private decimal SignificantFigures(decimal input, int f)
        {
            return decimal.Parse(input.ToString("g" + f.ToString()),NumberStyles.Float);
        }

        private decimal DecimalPlaces(decimal input, int p)
        {
            return decimal.Parse(input.ToString("f" + p.ToString()), NumberStyles.Float);
        }
    }
}
